// JavaScript Document<script type="text/javascript">
var cc;
var cs;

var tSp;

var pA;
var pB;
var pC;

var tA;
var tB;
var tC;

var euler;

//重心
var gArray;
//外心
var oArray;
//垂心
var hArray;
//内心
var iArray;
//傍心
var jArray;

var dPnt;

var color0;
var color1;
var color2;

var type;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

function loadContentHandler()
{
	try
	{
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		
		createjs.Touch.enable(cs);
		
		//初期化のため例外の値を設定
		type = -1;
		
		color0 = "#0096D9";
		color1 = "#169B3A";
		color2 = "#7D6B32";
		
		gArray = [];
		oArray = [];
		hArray = [];
		iArray = [];
		jArray = [];
		
		//オイラー線
		euler = new createjs.Shape();
		euler.name = "euler";
		cs.addChild(euler);
		
		//重心の線の描画
		gArray[2] = new createjs.Shape();
		cs.addChild(gArray[2]);
		
		//外心の円などの描画
		oArray[2] = new createjs.Shape();
		cs.addChild(oArray[2]);
		
		//垂心の円などの描画
		hArray[2] = new createjs.Shape();
		cs.addChild(hArray[2]);
		
		//内心の円などの描画
		iArray[2] = new createjs.Shape();
		cs.addChild(iArray[2]);
		
		//傍心の線などの描画
		jArray[2] = new createjs.Shape();
		cs.addChild(jArray[2]);
		
		//各点
		gArray[0] = createCenterPoint("G");
		oArray[0] = createCenterPoint("O");
		hArray[0] = createCenterPoint("H");
		iArray[0] = createCenterPoint("I");
		jArray[0] = createCenterPoint("J");
		
		//点のテキスト
		gArray[1] = createTextContainer("G");
		oArray[1] = createTextContainer("O");
		hArray[1] = createTextContainer("H");
		iArray[1] = createTextContainer("I");
		jArray[1] = createTextContainer("J");
		
		
		//頂点の文字
		tA = createTextContainer("A");
		tB = createTextContainer("B");
		tC = createTextContainer("C");
		
		//三角形
		tSp = new createjs.Shape();
		tSp.nam = "tSp";
		cs.addChild(tSp);
		
		//各頂点
		pA = createDragPoint();
		pA.name = "pA";
		pA.x = 350;
		pA.y = 150;
		pB = createDragPoint();
		pB.name = "pB";
		pB.x = 250;
		pB.y = 250;
		pC = createDragPoint();
		pC.name = "pC";
		pC.x = 400;
		pC.y = 250;
		
		cs.addChild(pA);
		cs.addChild(pB);
		cs.addChild(pC);
		
		pA.addEventListener("mousedown", pointDragStart);
		pB.addEventListener("mousedown", pointDragStart);
		pC.addEventListener("mousedown", pointDragStart);
		
		
		//教科書ごとでの機能制限
		document.getElementById("radio2").style.display = "none";
		document.getElementById("label2").style.display = "none";
		document.getElementById("radio4").style.display = "none";
		document.getElementById("label4").style.display = "none";
		document.getElementById("check0").style.display = "none";
		document.getElementById("label6").style.display = "none";
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("contentCanvas").style.float = "left";
		
		document.getElementById("expList").style.float = "left";
		document.getElementById("expList").style.width = "200px";
		
		document.getElementById("radio0").checked = true;
		
		document.getElementById("radio0").addEventListener("change", changeModeHandler);
		document.getElementById("radio1").addEventListener("change", changeModeHandler);
		document.getElementById("radio2").addEventListener("change", changeModeHandler);
		document.getElementById("radio3").addEventListener("change", changeModeHandler);
		document.getElementById("radio4").addEventListener("change", changeModeHandler);
		document.getElementById("radio5").addEventListener("change", changeModeHandler);
		
		document.getElementById("check0").checked = false;
		document.getElementById("check0").addEventListener("change", changeEulerHandler);
		
		document.getElementById("tBtn0").addEventListener("click", selectTriangleFigureHandler);
		document.getElementById("tBtn1").addEventListener("click", selectTriangleFigureHandler);
		document.getElementById("tBtn2").addEventListener("click", selectTriangleFigureHandler);
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		drawGravityCenter();
		drawOuterCenter();
		drawOrthoCenter();
		drawInnerCenter();
		drawExCenter();
		
		changeTriangleHandler(0);
		
		cs.update();
		
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function createTextContainer(str)
{
	try
	{
		var c = new createjs.Container();
		c.name = "t" + str;
		var t = new createjs.Text(str, "16px Times New Roman", "#000000");
		c.addChild(t);
		t.x = -t.getBounds().width/2;
		t.y = -t.getBounds().height/2;
		
		cs.addChild(c);
		
		return c;
	}
	catch(e)
	{
		alert("createTextContainer:" + e.toString());
	}
}

function createDragPoint(str)
{
	try
	{
		var s = new createjs.Shape();
		s.name = "c" + str;
		s.graphics.setStrokeStyle(0);
		s.graphics.beginStroke("rgba(255, 0, 0, 0.5)");
		s.graphics.beginFill("rgba(255, 0, 0, 0.5)");
		s.graphics.drawCircle(0, 0, 4);
		s.graphics.endFill();
		s.graphics.beginStroke("rgba(255, 255, 255, 0.05)");
		s.graphics.beginFill("rgba(255, 255, 255, 0.05)");
		s.graphics.drawCircle(0, 0, 15);
		s.graphics.endFill();
		s.graphics.endStroke();
		
		cs.addChild(s);
		
		return s;
	}
	catch(e)
	{
		alert("createDragPoint:" + e.toString());
	}
}

function createCenterPoint()
{
	try
	{
		var s = new createjs.Shape();
		
		s.graphics.setStrokeStyle(0);
		s.graphics.beginStroke("#000000");
		s.graphics.beginFill("#000000");
		s.graphics.drawCircle(0, 0, 3);
		s.graphics.endFill();
		s.graphics.endStroke();
		
		cs.addChild(s);
		
		return s;
	}
	catch(e)
	{
		alert("createCenterPoint:" + e.toString());
	}
}

function selectTriangleFigureHandler(e)
{
	try
	{
		switch(e.target.id)
		{
			//正三角形
			case "tBtn0":
				pA.x = 350;
				pA.y = 150;
				pB.x = 350 - 100/Math.sqrt(3);
				pB.y = 250;
				pC.x = 350 + 100/Math.sqrt(3);
				pC.y = 250;
				break;
			//二等辺三角形
			case "tBtn1":
				pA.x = 350;
				pA.y = 150;
				pB.x = 350 - 100;
				pB.y = 250;
				pC.x = 350 + 100;
				pC.y = 250;
				break;
			//直角三角形
			case "tBtn2":
				pA.x = 450;
				pA.y = 150;
				pB.x = 250;
				pB.y = 250;
				pC.x = 450;
				pC.y = 250;
				break;
		}
		
		drawTriangleHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("selectTriangleFigureHandler:" + e.toString());
	}
}

//重心
function drawGravityCenter(f)
{
	try
	{
		gArray[0].x = (pA.x + pB.x + pC.x)/3;
		gArray[0].y = (pA.y + pB.y + pC.y)/3;
		
		gArray[1].x = gArray[0].x + 10;
		gArray[1].y = gArray[0].y + 10;
		
		//補助線
		if(f)
		{
			gArray[2].graphics.clear();
			gArray[2].graphics.setStrokeStyle(1.5);
			gArray[2].graphics.beginStroke(color0);
			gArray[2].graphics.moveTo(pA.x, pA.y);
			gArray[2].graphics.lineTo((pB.x+pC.x)/2, (pB.y+pC.y)/2);
			gArray[2].graphics.beginStroke(color1);
			gArray[2].graphics.moveTo(pB.x, pB.y);
			gArray[2].graphics.lineTo((pC.x+pA.x)/2, (pC.y+pA.y)/2);
			gArray[2].graphics.beginStroke(color2);
			gArray[2].graphics.moveTo(pC.x, pC.y);
			gArray[2].graphics.lineTo((pA.x+pB.x)/2, (pA.y+pB.y)/2);
			gArray[2].graphics.endStroke();
		}
	}
	catch(e)
	{
		alert("drawGravityCenter:" + e.toString());
	}
}

//外心
function drawOuterCenter(f)
{
	try
	{
		rArray = getTriangleAngle();
		
		var rA = rArray[0];
		var rB = rArray[1];
		var rC = rArray[2];
		
		oArray[0].x = (pA.x * Math.sin(2 * rA) + pB.x * Math.sin(2 * rB) + pC.x * Math.sin(2 * rC))/(Math.sin(2 * rA) + Math.sin(2 * rB) + Math.sin(2 * rC));
		oArray[0].y = (pA.y * Math.sin(2 * rA) + pB.y * Math.sin(2 * rB) + pC.y * Math.sin(2 * rC))/(Math.sin(2 * rA) + Math.sin(2 * rB) + Math.sin(2 * rC));
		
		oArray[1].x = oArray[0].x + 10;
		oArray[1].y = oArray[0].y + 10;
		
		var c0 = "#EF7F46";
		var c1 = "#31B1EC";
		var c2 = "#E5001A";
		
		
		//補助線
		if(f)
		{
			var r = Math.sqrt((pA.x-oArray[0].x) * (pA.x-oArray[0].x) + (pA.y-oArray[0].y) * (pA.y-oArray[0].y));
			
			oArray[2].x = oArray[0].x;
			oArray[2].y = oArray[0].y;
			
			oArray[2].graphics.clear();
			oArray[2].graphics.setStrokeStyle(1.5);
			oArray[2].graphics.beginStroke(c0);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(pA.x-oArray[0].x, pA.y-oArray[0].y);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(pB.x-oArray[0].x, pB.y-oArray[0].y);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(pC.x-oArray[0].x, pC.y-oArray[0].y);
			oArray[2].graphics.endStroke();
			
			oArray[2].graphics.setStrokeStyle(1.5);
			oArray[2].graphics.beginStroke(c2);
			oArray[2].graphics.drawCircle(0, 0, r);
			oArray[2].graphics.endStroke();
			
			var px0 = (pA.x+pB.x)/2-oArray[2].x;
			var py0 = (pA.y+pB.y)/2-oArray[2].y;
			
			if(px0.toString().indexOf("e") != -1)
			{
				px0 = 0;
			}
			
			if(py0.toString().indexOf("e") != -1)
			{
				py0 = 0;
			}
			
			var px1 = (pB.x+pC.x)/2-oArray[2].x;
			var py1 = (pB.y+pC.y)/2-oArray[2].y;
			
			if(px1.toString().indexOf("e") != -1)
			{
				px1 = 0;
			}
			
			if(py1.toString().indexOf("e") != -1)
			{
				py1 = 0;
			}
			
			var px2 = (pC.x+pA.x)/2-oArray[2].x;
			var py2 = (pC.y+pA.y)/2-oArray[2].y;
			
			
			if(px2.toString().indexOf("e") != -1)
			{
				px2 = 0;
			}
			
			if(py2.toString().indexOf("e") != -1)
			{
				py2 = 0;
			}
			
			
			oArray[2].graphics.beginStroke(c1);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(px0, py0);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(px1, py1);
			oArray[2].graphics.moveTo(0, 0);
			oArray[2].graphics.lineTo(px2, py2);
			
			if(!(px0 == 0 && py0 == 0))
			{
				drawVerticalSymbol(oArray[2], 0, 0, px0, py0, c1);
			}
			
			if(!(px1 == 0 && py1 == 0))
			{
				drawVerticalSymbol(oArray[2], 0, 0, px1, py1, c1);
			}
			
			if(!(px2 == 0 && py2 == 0))
			{
				drawVerticalSymbol(oArray[2], 0, 0, px2, py2, c1);
			}
		}
	}
	catch(e)
	{
		alert("drawOuterCenter:" + e.toString());
	}
}

//垂心
function drawOrthoCenter(f)
{
	try
	{
		rArray = getTriangleAngle();
		var rA = rArray[0];
		var rB = rArray[1];
		var rC = rArray[2];
		
		hArray[0].x = (pA.x*Math.tan(rA)+pB.x*Math.tan(rB)+pC.x*Math.tan(rC))/(Math.tan(rA)+Math.tan(rB)+Math.tan(rC));
		hArray[0].y = (pA.y*Math.tan(rA)+pB.y*Math.tan(rB)+pC.y*Math.tan(rC))/(Math.tan(rA)+Math.tan(rB)+Math.tan(rC));
		
		hArray[1].x = hArray[0].x + 10;
		hArray[1].y = hArray[0].y + 10;
		
		//補助線
		if(f)
		{
			var a = Math.sqrt((pB.x-pC.x)*(pB.x-pC.x)+(pB.y-pC.y)*(pB.y-pC.y));
			var b = Math.sqrt((pC.x-pA.x)*(pC.x-pA.x)+(pC.y-pA.y)*(pC.y-pA.y));
			var c = Math.sqrt((pA.x-pB.x)*(pA.x-pB.x)+(pA.y-pB.y)*(pA.y-pB.y));
			
			var fa = false;
			var fb = false;
			var fc = false;
			
			//変に下した点の位置
			var aH = getVerticalPoint(pA.x, pA.y, pB.x, pB.y, pC.x, pC.y);
			var bH = getVerticalPoint(pB.x, pB.y, pC.x, pC.y, pA.x, pA.y);
			var cH = getVerticalPoint(pC.x, pC.y, pA.x, pA.y, pB.x, pB.y);
			
			//描画のクリア
			hArray[2].graphics.clear();
			hArray[2].graphics.setStrokeStyle(1.5);
			
			var aHB = Math.sqrt((pB.x-aH[0])*(pB.x-aH[0])+(pB.y-aH[1])*(pB.y-aH[1]));
			var aHC = Math.sqrt((pC.x-aH[0])*(pC.x-aH[0])+(pC.y-aH[1])*(pC.y-aH[1]));
			var bHA = Math.sqrt((pA.x-bH[0])*(pA.x-bH[0])+(pA.y-bH[1])*(pA.y-bH[1]));
			var bHC = Math.sqrt((pC.x-bH[0])*(pC.x-bH[0])+(pC.y-bH[1])*(pC.y-bH[1]));
			var cHA = Math.sqrt((pA.x-cH[0])*(pA.x-cH[0])+(pA.y-cH[1])*(pA.y-cH[1]));
			var cHB = Math.sqrt((pB.x-cH[0])*(pB.x-cH[0])+(pB.y-cH[1])*(pB.y-cH[1]));
			
			hArray[2].graphics.beginStroke("#999999");
			
			//BCと垂線が外分の場合
			if(a < aHB+aHC)
			{
				var lengBAH = Math.sqrt((aH[0]-pB.x)*(aH[0]-pB.x)+(aH[1]-pB.y)*(aH[1]-pB.y));
				var rB = Math.atan2(aH[1]-pB.y, aH[0]-pB.x);
				hArray[2].graphics.moveTo(pB.x, pB.y);
				hArray[2].graphics.lineTo(pB.x + (lengBAH+20) * Math.cos(rB), pB.y + (lengBAH+20) * Math.sin(rB));
			}
			
			//CAと垂線が外分の場合
			if(b < bHA+bHC)
			{
				var lengCBH = Math.sqrt((bH[0]-pC.x)*(bH[0]-pC.x)+(bH[1]-pC.y)*(bH[1]-pC.y));
				var rC = Math.atan2(bH[1]-pC.y, bH[0]-pC.x);
				hArray[2].graphics.moveTo(pC.x, pC.y);
				hArray[2].graphics.lineTo(pC.x + (lengCBH+20) * Math.cos(rC), pC.y + (lengCBH+20) * Math.sin(rC));
			}
			
			//ABと垂線が外分の場合
			if(c < cHA+cHB)
			{
				var lengACH = Math.sqrt((cH[0]-pA.x)*(cH[0]-pA.x)+(cH[1]-pA.y)*(cH[1]-pA.y));
				var rA = Math.atan2(cH[1]-pA.y, cH[0]-pA.x);
				hArray[2].graphics.moveTo(pA.x, pA.y);
				hArray[2].graphics.lineTo(pA.x + (lengACH+20) * Math.cos(rA), pA.y + (lengACH+20) * Math.sin(rA));
			}
			
			//垂直の線分
			hArray[2].graphics.beginStroke(color1);
			
			hArray[2].graphics.moveTo(pA.x, pA.y);
			hArray[2].graphics.lineTo(aH[0], aH[1]);
			
			hArray[2].graphics.moveTo(pB.x, pB.y);
			hArray[2].graphics.lineTo(bH[0], bH[1]);
			
			hArray[2].graphics.moveTo(pC.x, pC.y);
			hArray[2].graphics.lineTo(cH[0], cH[1]);
			
			hArray[2].graphics.setStrokeDash([5, 5], 0);
			
			hArray[2].graphics.moveTo(aH[0], aH[1]);
			hArray[2].graphics.lineTo(hArray[0].x, hArray[0].y);
			hArray[2].graphics.moveTo(bH[0], bH[1]);
			hArray[2].graphics.lineTo(hArray[0].x, hArray[0].y);
			hArray[2].graphics.moveTo(cH[0], cH[1]);
			hArray[2].graphics.lineTo(hArray[0].x, hArray[0].y);
			
			//破線の解除
			hArray[2].graphics.setStrokeDash(null);
			
			drawVerticalSymbol(hArray[2], pA.x, pA.y, aH[0], aH[1]);
			drawVerticalSymbol(hArray[2], pB.x, pB.y, bH[0], bH[1]);
			drawVerticalSymbol(hArray[2], pC.x, pC.y, cH[0], cH[1]);
			
			hArray[2].graphics.endStroke();
			
		}
	}
	catch(e)
	{
		alert("drawOrthoCenter:" + e.toString());
	}
}

//垂直に下した点
function getVerticalPoint(Px, Py, Ax, Ay, Bx, By)
{
	try
	{
		var ax = Bx-Ax;
		var ay = By-Ay;
		var bx = Px-Ax;
		var by = Py-Ay;
		
		var r = (ax * bx + ay * by)/(ax * ax + ay * ay);
		
		var array = [];
		
		array[0] = Ax + r * ax;
		array[1] = Ay + r * ay;
		
		return array;
	}
	catch(e)
	{
		alert("getVerticalPoint:" + e.toString());
	}
}

//内心
function drawInnerCenter(f)
{
	try
	{
		var c0 = "#EF7F46";
		var c1 = "#31B1EC";
		var c2 = "#E5001A";
		
		var a = Math.sqrt((pB.x-pC.x)*(pB.x-pC.x)+(pB.y-pC.y)*(pB.y-pC.y));
		var b = Math.sqrt((pC.x-pA.x)*(pC.x-pA.x)+(pC.y-pA.y)*(pC.y-pA.y));
		var c = Math.sqrt((pA.x-pB.x)*(pA.x-pB.x)+(pA.y-pB.y)*(pA.y-pB.y));
		
		iArray[0].x = (a*pA.x+b*pB.x+c*pC.x)/(a+b+c);
		iArray[0].y = (a*pA.y+b*pB.y+c*pC.y)/(a+b+c);
		
		iArray[1].x = iArray[0].x + 10;
		iArray[1].y = iArray[0].y + 10;
		
		//補助線
		if(f)
		{
			var s = (a+b+c)/2;
			var S = Math.sqrt(s*(s-a)*(s-b)*(s-c));
			
			var r = (2 * S)/(a+b+c);
			
			iArray[2].x = iArray[0].x;
			iArray[2].y = iArray[0].y;
			
			iArray[2].graphics.clear();
			iArray[2].graphics.setStrokeStyle(1.5);
			iArray[2].graphics.beginStroke(c2);
			iArray[2].graphics.drawCircle(0, 0, r);
			iArray[2].graphics.endStroke();
			
			var aH = getVerticalPoint(iArray[0].x, iArray[0].y, pA.x, pA.y, pB.x, pB.y);
			var bH = getVerticalPoint(iArray[0].x, iArray[0].y, pB.x, pB.y, pC.x, pC.y);
			var cH = getVerticalPoint(iArray[0].x, iArray[0].y, pC.x, pC.y, pA.x, pA.y);
			
			var px0 = aH[0]-iArray[0].x;
			var py0 = aH[1]-iArray[0].y;
			var px1 = bH[0]-iArray[0].x;
			var py1 = bH[1]-iArray[0].y;
			var px2 = cH[0]-iArray[0].x;
			var py2 = cH[1]-iArray[0].y;
			
			iArray[2].graphics.setStrokeStyle(1.5);
			iArray[2].graphics.beginStroke(c0);
			iArray[2].graphics.moveTo(0, 0);
			iArray[2].graphics.lineTo(px0, py0);
			iArray[2].graphics.moveTo(0, 0);
			iArray[2].graphics.lineTo(px1, py1);
			iArray[2].graphics.moveTo(0, 0);
			iArray[2].graphics.lineTo(px2, py2);
			iArray[2].graphics.endStroke();
			
			drawVerticalSymbol(iArray[2], 0, 0, px0, py0, c2);
			drawVerticalSymbol(iArray[2], 0, 0, px1, py1, c2);
			drawVerticalSymbol(iArray[2], 0, 0, px2, py2, c2);
			drawVerticalSymbol(iArray[2], 0, 0, px2, py2, c2);
		}
	}
	catch(e)
	{
		alert("drawInnerCenter:" + e.toString());
	}
}

//傍心
function drawExCenter(f)
{
	try
	{
		var a = Math.sqrt((pB.x-pC.x)*(pB.x-pC.x)+(pB.y-pC.y)*(pB.y-pC.y));
		var b = Math.sqrt((pC.x-pA.x)*(pC.x-pA.x)+(pC.y-pA.y)*(pC.y-pA.y));
		var c = Math.sqrt((pA.x-pB.x)*(pA.x-pB.x)+(pA.y-pB.y)*(pA.y-pB.y));
		
		jArray[0].x = (-a*pA.x+b*pB.x+c*pC.x)/(-a+b+c);
		jArray[0].y = (-a*pA.y+b*pB.y+c*pC.y)/(-a+b+c);
		
		jArray[1].x = jArray[0].x+10;
		jArray[1].y = jArray[0].y+10;
		
		//補助線
		if(f)
		{
			jArray[2].graphics.clear();
			jArray[2].graphics.setStrokeStyle(1.5);
			jArray[2].graphics.setStrokeDash([5,5], 0);
			jArray[2].graphics.beginStroke(color1);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(pA.x, pA.y);
			jArray[2].graphics.setStrokeDash(null);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(pB.x, pB.y);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(pC.x, pC.y);
			
			var rBA = Math.atan2(pB.y-pA.y, pB.x-pA.x);
			var rCA = Math.atan2(pC.y-pA.y, pC.x-pA.x);
			
			//垂線
			var jBC = getVerticalPoint(jArray[0].x, jArray[0].y, pB.x, pB.y, pC.x, pC.y);
			var jAB = getVerticalPoint(jArray[0].x, jArray[0].y, pA.x, pA.y, pB.x, pB.y);
			var jAC = getVerticalPoint(jArray[0].x, jArray[0].y, pA.x, pA.y, pC.x, pC.y);
			
			jArray[2].graphics.beginStroke(color0);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(jBC[0], jBC[1]);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(jAB[0], jAB[1]);
			jArray[2].graphics.moveTo(jArray[0].x, jArray[0].y);
			jArray[2].graphics.lineTo(jAC[0], jAC[1]);
			jArray[2].graphics.endStroke();
			
			drawVerticalSymbol(jArray[2], jArray[0].x, jArray[0].y, jBC[0], jBC[1]);
			drawVerticalSymbol(jArray[2], jArray[0].x, jArray[0].y, jAB[0], jAB[1]);
			drawVerticalSymbol(jArray[2], jArray[0].x, jArray[0].y, jAC[0], jAC[1]);
			
			var lengAB = Math.sqrt((pB.x-pA.x)*(pB.x-pA.x)+(pB.y-pA.y)*(pB.y-pA.y));
			var lengAC = Math.sqrt((pC.x-pA.x)*(pC.x-pA.x)+(pC.y-pA.y)*(pC.y-pA.y));
			
			var lengAF = Math.sqrt((jAB[0]-pA.x)*(jAB[0]-pA.x)+(jAB[1]-pA.y)*(jAB[1]-pA.y));
			var lengAE = Math.sqrt((jAC[0]-pA.x)*(jAC[0]-pA.x)+(jAC[1]-pA.y)*(jAC[1]-pA.y));
			
			if(lengAB < lengAF)
			{
				var rAB = Math.atan2(pB.y-pA.y, pB.x-pA.x);
				var pX0 = pA.x + (lengAF+20) * Math.cos(rAB);
				var pY0 = pA.y + (lengAF+20) * Math.sin(rAB);
				
				jArray[2].graphics.setStrokeStyle(1.5);
				jArray[2].graphics.beginStroke("#999999");
				jArray[2].graphics.moveTo(pA.x, pA.y);
				jArray[2].graphics.lineTo(pX0, pY0);
				jArray[2].graphics.endStroke();
			}
			
			if(lengAC < lengAE)
			{
				var rAC = Math.atan2(pC.y-pA.y, pC.x-pA.x);
				var pX1 = pA.x + (lengAE+20) * Math.cos(rAC);
				var pY1 = pA.y + (lengAE+20) * Math.sin(rAC);
				
				jArray[2].graphics.setStrokeStyle(1.5);
				jArray[2].graphics.beginStroke("#999999");
				jArray[2].graphics.moveTo(pA.x, pA.y);
				jArray[2].graphics.lineTo(pX1, pY1);
				jArray[2].graphics.endStroke();
			}
		}
	}
	catch(e)
	{
		alert("drawExCenter:" + e.toString());
	}
}

function getTriangleAngle()
{
	try
	{
		var rA = Math.atan2(pB.y-pA.y, pB.x-pA.x)-Math.atan2(pC.y-pA.y, pC.x-pA.x);
		var rB = Math.atan2(pC.y-pB.y, pC.x-pB.x)-Math.atan2(pA.y-pB.y, pA.x-pB.x);
		var rC = Math.atan2(pA.y-pC.y, pA.x-pC.x)-Math.atan2(pB.y-pC.y, pB.x-pC.x);
		
		return [rA, rB, rC];
	}
	catch(e)
	{
		alert("getTriangleAngle:" + e.toString());
	}
}

function changeEulerHandler(e)
{
	try
	{
		if(e.target.checked && document.getElementById("radio5").checked)
		{
			drawEuler();
			
			euler.visible = true;
		}
		else
		{
			euler.visible = false;
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("changeEulerHandler:" + e.toString());
	}
}

function changeModeHandler(e)
{
	try
	{
		t = parseInt(e.target.id.substring(5, 6));
		
		changeTriangleHandler(t);
		
		cs.update();
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function pointDragStart(e)
{
	try
	{
		dPnt = e.target.name;
		
		cs.getChildByName(dPnt).addEventListener("pressmove", pointDragMove);
		document.addEventListener("mouseout", pointDragStop);
		document.addEventListener("mouseup", pointDragStop);
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}

function pointDragMove(e)
{
	try
	{
		cs.getChildByName(dPnt).x = e.stageX;
		cs.getChildByName(dPnt).y = e.stageY;
		
		drawTriangleHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("pointDragMove:" + e.toString());
	}
}

function pointDragStop(e)
{
	try
	{
		cs.getChildByName(dPnt).removeEventListener("pressmove", pointDragMove);
		document.removeEventListener("mouseout", pointDragStop);
		document.removeEventListener("mouseup", pointDragStop);
	}
	catch(e)
	{
		alert("pointDragStop:" + e.toString());
	}
}

function changeTriangleHandler(t)
{
	try
	{	
		switch(type)
		{
			//重心
			case 0:
				gArray[0].visible = false;
				gArray[1].visible = false;
				gArray[2].visible = false;
				break;
			//外心
			case 1:
				oArray[0].visible = false;
				oArray[1].visible = false;
				oArray[2].visible = false;
				break;
			//垂心
			case 2:
				hArray[0].visible = false;
				hArray[1].visible = false;
				hArray[2].visible = false;
				break;
			//内心
			case 3:
				iArray[0].visible = false;
				iArray[1].visible = false;
				iArray[2].visible = false;
				break;
			//傍心
			case 4:
				jArray[0].visible = false;
				jArray[1].visible = false;
				jArray[2].visible = false;
				break;
			//五心の点
			case 5:
				gArray[0].visible = false;
				gArray[1].visible = false;
				oArray[0].visible = false;
				oArray[1].visible = false;
				hArray[0].visible = false;
				hArray[1].visible = false;
				iArray[0].visible = false;
				iArray[1].visible = false;
				jArray[0].visible = false;
				jArray[1].visible = false;
				break;
			//初期化
			default:
				gArray[0].visible = false;
				gArray[1].visible = false;
				gArray[2].visible = false;
				oArray[0].visible = false;
				oArray[1].visible = false;
				oArray[2].visible = false;
				hArray[0].visible = false;
				hArray[1].visible = false;
				hArray[2].visible = false;
				iArray[0].visible = false;
				iArray[1].visible = false;
				iArray[2].visible = false;
				jArray[0].visible = false;
				jArray[1].visible = false;
				jArray[2].visible = false;
				break;
		}
		
		switch(t)
		{
			//重心
			case 0:
				gArray[0].visible = true;
				gArray[1].visible = true;
				gArray[2].visible = true;
				break;
			//外心
			case 1:
				oArray[0].visible = true;
				oArray[1].visible = true;
				oArray[2].visible = true;
				break;
			//垂心
			case 2:
				hArray[0].visible = true;
				hArray[1].visible = true;
				hArray[2].visible = true;
				break;
			//内心
			case 3:
				iArray[0].visible = true;
				iArray[1].visible = true;
				iArray[2].visible = true;
				break;
			//傍心
			case 4:
				jArray[0].visible = true;
				jArray[1].visible = true;
				jArray[2].visible = true;
				break;
			//五心の点
			case 5:
				gArray[0].visible = true;
				gArray[1].visible = true;
				oArray[0].visible = true;
				oArray[1].visible = true;
				hArray[0].visible = false;
				hArray[1].visible = false;
				iArray[0].visible = true;
				iArray[1].visible = true;
				jArray[0].visible = false;
				jArray[1].visible = false;
				break;
		}
		
		//タイプを変更
		type = t;
		
		if(document.getElementById("check0").checked && document.getElementById("radio5").checked)
		{
			euler.visible = true;
		}
		else
		{
			euler.visible = false;
		}
		
		//三角形の線と頂点の記号を描画
		drawTriangleHandler();
	}
	catch(e)
	{
		alert("changeTriangleHandler:" + e.toString());
	}
}

function drawEuler()
{
	try
	{
		//オイラー線のための
		//重心の場合
		if(type == 0)
		{
			drawOuterCenter(false);
			drawOrthoCenter(false);
		}
		//外心の場合
		else if(type == 1)
		{
			drawGravityCenter(false);
			drawOrthoCenter(false);
		}
		//垂心の場合
		else if(type == 2)
		{
			drawGravityCenter(false);
			drawOuterCenter(false);
		}
		//五心の表示以外
		else if(type != 5)
		{
			drawGravityCenter(false);
			drawOuterCenter(false);
			drawOrthoCenter(false);
		}
		
		//距離を比較
		var pX0;
		var pY0;
		var pX1;
		var pY0;
		
		var leng0;
		var leng1;
		var r;
		
		if(gArray[0].x <= oArray[0].x && gArray[0].x <= hArray[0].x)
		{
			leng0 = Math.sqrt((oArray[0].x-gArray[0].x)*(oArray[0].x-gArray[0].x)+(oArray[0].y-gArray[0].y)*(oArray[0].y-gArray[0].y));
			leng1 = Math.sqrt((hArray[0].x-gArray[0].x)*(hArray[0].x-gArray[0].x)+(hArray[0].y-gArray[0].y)*(hArray[0].y-gArray[0].y));
			
			if(leng0 > leng1)
			{
				r = Math.atan2(oArray[0].y-gArray[0].y, oArray[0].x-gArray[0].x);
			
				pX0 = gArray[0].x + (leng0+100) * Math.cos(r);
				pY0 = gArray[0].y + (leng0+100) * Math.sin(r);
			}
			else
			{
				r = Math.atan2(hArray[0].y-gArray[0].y, hArray[0].x-gArray[0].x);
				
				pX0 = gArray[0].x + (leng1+100) * Math.cos(r);
				pY0 = gArray[0].y + (leng1+100) * Math.sin(r);
			}
			
			
			pX1 = gArray[0].x + 100 * Math.cos(r+Math.PI);
			pY1 = gArray[0].y + 100 * Math.sin(r+Math.PI);
		}
		else if(oArray[0].x <= gArray[0].x && oArray[0].x <= hArray[0].x)
		{
			leng0 = Math.sqrt((gArray[0].x-oArray[0].x)*(gArray[0].x-oArray[0].x)+(gArray[0].y-oArray[0].y)*(gArray[0].y-oArray[0].y));
			leng1 = Math.sqrt((hArray[0].x-oArray[0].x)*(hArray[0].x-oArray[0].x)+(hArray[0].y-oArray[0].y)*(hArray[0].y-oArray[0].y));
		
			if(leng0 > leng1)
			{
				r = Math.atan2(gArray[0].y-oArray[0].y, gArray[0].x-oArray[0].x);
			
				pX0 = oArray[0].x + (leng0+100) * Math.cos(r);
				pY0 = oArray[0].y + (leng0+100) * Math.sin(r);
			}
			else
			{
				r = Math.atan2(hArray[0].y-oArray[0].y, hArray[0].x-oArray[0].x);
				
				pX0 = oArray[0].x + (leng1+100) * Math.cos(r);
				pY0 = oArray[0].y + (leng1+100) * Math.sin(r);
			}
			
			pX1 = oArray[0].x + 100 * Math.cos(r+Math.PI);
			pY1 = oArray[0].y + 100 * Math.sin(r+Math.PI);
		}
		else
		{
			leng0 = Math.sqrt((gArray[0].x-hArray[0].x)*(gArray[0].x-hArray[0].x)+(gArray[0].y-hArray[0].y)*(gArray[0].y-hArray[0].y));
			leng1 = Math.sqrt((oArray[0].x-hArray[0].x)*(oArray[0].x-hArray[0].x)+(oArray[0].y-hArray[0].y)*(oArray[0].y-hArray[0].y));
		
			if(leng0 > leng1)
			{
				r = Math.atan2(gArray[0].y-hArray[0].y, gArray[0].x-hArray[0].x);
			
				pX0 = hArray[0].x + (leng0+100) * Math.cos(r);
				pY0 = hArray[0].y + (leng0+100) * Math.sin(r);
			}
			else
			{
				r = Math.atan2(oArray[0].y-hArray[0].y, oArray[0].x-hArray[0].x);
				
				pX0 = hArray[0].x + (leng1+100) * Math.cos(r);
				pY0 = hArray[0].y + (leng1+100) * Math.sin(r);
			}
			
			pX1 = hArray[0].x + 100 * Math.cos(r+Math.PI);
			pY1 = hArray[0].y + 100 * Math.sin(r+Math.PI);
		}
		
		//オイラー線の描画
		euler.graphics.clear();
		euler.graphics.setStrokeStyle(1.5);
		euler.graphics.beginStroke("#FF2222");
		euler.graphics.moveTo(pX0, pY0);
		euler.graphics.lineTo(pX1, pY1);
		euler.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawEulerHandler:" + e.toString());
	}
}

//垂直の記号
function drawVerticalSymbol(sp, px0, py0, px1, py1, cStr)
{
	try
	{
		if(cStr == null)
		{
			cStr = "#000000";
		}
		
		var span0 = 10;
		var span1 = 10 * Math.sqrt(2);
		var span2 = 20;
		
		sp.graphics.setStrokeStyle(1.5);
		sp.graphics.beginStroke(cStr);
		
		var r0 = Math.atan2(py0-py1, px0-px1);
		var r1 = r0+Math.PI/4;
		var r2 = r0+Math.PI/2;
		
		sp.graphics.moveTo(px1+span0*Math.cos(r0), py1+span0*Math.sin(r0));
		sp.graphics.lineTo(px1+span1*Math.cos(r1), py1+span1*Math.sin(r1));
		sp.graphics.lineTo(px1+span0*Math.cos(r2), py1+span0*Math.sin(r2));
		
		sp.graphics.beginStroke("#999999");
		sp.graphics.moveTo(px1, py1);
		sp.graphics.lineTo(px1+span2*Math.cos(r2), py1+span2*Math.sin(r2));
		
		sp.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawVerticalSymbol:" + e.toString());
	}
}

function drawTriangleHandler()
{
	try
	{
		//タイプごとの描画の変更
		switch(type)
		{
			//重心
			case 0:
				drawGravityCenter(true);
				break;
			//外心
			case 1:
				drawOuterCenter(true);
				break;
			//垂心
			case 2:
				drawOrthoCenter(true);
				break;
			//内心
			case 3:
				drawInnerCenter(true);
				break;
			//傍心
			case 4:
				drawExCenter(true);
				break;
			//五心の点
			case 5:
				drawGravityCenter(false);
				drawOuterCenter(false);
				drawOrthoCenter(false);
				drawInnerCenter(false);
				drawExCenter(false);
				break;
		}
		
		if(document.getElementById("check0").checked && document.getElementById("radio5").checked)
		{
			drawEuler();
		}
		
		drawTriangleFrameHandler();
	}
	catch(e)
	{
		alert("drawTriangleHandler:" + e.toString());
	}
}

function drawTriangleFrameHandler()
{
	try
	{
		//△ABCの線の描画
		tSp.graphics.clear();
		tSp.graphics.setStrokeStyle(1.5);
		tSp.graphics.beginStroke("#000000");
		tSp.graphics.moveTo(pA.x, pA.y);
		tSp.graphics.lineTo(pB.x, pB.y);
		tSp.graphics.lineTo(pC.x, pC.y);
		tSp.graphics.lineTo(pA.x, pA.y);
		tSp.graphics.lineTo(pB.x, pB.y);
		tSp.graphics.endStroke();
		
		//テキストの位置
		var gX = (pA.x+pB.x+pC.x)/3;
		var gY = (pA.y+pB.y+pC.y)/3;
		
		var lengA = Math.sqrt((gX-pA.x)*(gX-pA.x)+(gY-pA.y)*(gY-pA.y));
		var lengB = Math.sqrt((gX-pB.x)*(gX-pB.x)+(gY-pB.y)*(gY-pB.y));
		var lengC = Math.sqrt((gX-pC.x)*(gX-pC.x)+(gY-pC.y)*(gY-pC.y));
		
		var rA = Math.atan2(pA.y-gY, pA.x-gX);
		var rB = Math.atan2(pB.y-gY, pB.x-gX);
		var rC = Math.atan2(pC.y-gY, pC.x-gX);
		
		tA.x = gX + (lengA+10) * Math.cos(rA);
		tA.y = gY + (lengA+10) * Math.sin(rA);
		tB.x = gX + (lengB+10) * Math.cos(rB);
		tB.y = gY + (lengB+10) * Math.sin(rB);
		tC.x = gX + (lengC+10) * Math.cos(rC);
		tC.y = gY + (lengC+10) * Math.sin(rC);
	}
	catch(e)
	{
		alert("drawTriangleHandler:" + e.toString());
	}
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = type;
		
		array[1] = [];
		array[1][0] = [pA.x, pA.y];
		array[1][1] = [pB.x, pB.y];
		array[1][2] = [pC.x, pC.y];
		
		array[2] = document.getElementById("check0").checked;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		//位置の修正
		pA.x = array[1][0][0];
		pA.y = array[1][0][1];
		
		pB.x = array[1][1][0];
		pB.y = array[1][1][1];
		
		pC.x = array[1][2][0];
		pC.y = array[1][2][1];
		
		//オイラー線の表示
		document.getElementById("check0").checked = array[2];
		
		document.getElementById("radio"+array[0]).checked = true;
		
		//タイプと描画を変更
		changeTriangleHandler(array[0]);
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}


function resetHandler(e)
{
	try
	{
		//位置の初期化
		pA.x = 350;
		pA.y = 150;
		pB.x = 250;
		pB.y = 250;
		pC.x = 400;
		pC.y = 250;
		
		//初期の重心表示
		document.getElementById("radio0").checked = true;
		
		//オイラー線の表示
		document.getElementById("check0").checked = false;
		
		changeTriangleHandler(0);
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}



