
//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

// JavaScript Document
function loadContentHandler()
{
	try
	{
		mFlag = false;
		rotFlag = true;
		var ua = navigator.userAgent;
		
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			mFlag = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			mFlag = true;
		}
		
		document.getElementById("rotNum").style.position ="absolute";
		document.getElementById("rotNum").style.top ="0px";
		document.getElementById("rotNum").style.right ="10px";
		document.getElementById("rotNum").style.textAlign ="right";
		document.getElementById("rotNum").style.fontSize ="1.6em";
		document.getElementById("rotNum").style.display = "inline";
		
		document.getElementById("disc0").style.fontWeight = "bolder";
		document.getElementById("disc1").style.marginLeft = "20px";
		document.getElementById("disc1").style.fontWeight = "bolder";
		
		document.getElementById("resetBtn").style.marginLeft = "20px";
		
		if(ictMode)
		{
			$("#rotRight").on("mousedown touchstart", rotatePlaneHandler);
			$("#rotLeft").on("mousedown touchstart", rotatePlaneHandler);
			$("#moveUpBtn").on("mousedown touchstart", movePointHandler);
			$("#moveDownBtn").on("mousedown touchstart", movePointHandler);
		}
		else if(mFlag)
		{
			document.getElementById("rotRight").addEventListener("touchstart", rotatePlaneHandler);
			document.getElementById("rotLeft").addEventListener("touchstart", rotatePlaneHandler);
			document.getElementById("moveUpBtn").addEventListener("touchstart", movePointHandler);
			document.getElementById("moveDownBtn").addEventListener("touchstart", movePointHandler);
		}
		else
		{
			document.getElementById("rotRight").addEventListener("mousedown", rotatePlaneHandler);
			document.getElementById("rotLeft").addEventListener("mousedown", rotatePlaneHandler);
			document.getElementById("moveUpBtn").addEventListener("mousedown", movePointHandler);
			document.getElementById("moveDownBtn").addEventListener("mousedown", movePointHandler);
		}
		
		document.getElementById("cameraBtn").addEventListener("click", changeCameraPositionHandler);
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		init();
		
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

var canvas;
var stage;

           
var scene;
var camera;
var renderer;
var controls;
var projector;

var textArray;

var obj;

var pA;
var pB;

var lineA;
var lineB;

var lineMaterial;
var planeMaterialA;
var planeMaterialB;
var arcMaterial;

var pW;
var pD;

var arc0;
var arc1;

var leng;

var rdFlag;

function init()
{
	try
	{
		var dis = 22;
		
		var w = 800;
		var h = 450;
		
		leng = 2;
		
		pW = 15;
		pD = pW * 1.8;
		
		//3Dの設定
		scene = new THREE.Scene();
		
		if(navigator.userAgent.indexOf("Chrome") != -1)
		{
			renderer = new THREE.WebGLRenderer({antialias: false});
		}
		else
		{
			renderer = new THREE.WebGLRenderer({antialias: true});
		}
		
		renderer.setSize(w, h);
		renderer.setClearColor( new THREE.Color(0xFFFFFF) );
		
		camera = new THREE.OrthographicCamera (-w/dis, w/dis, h/dis, -h/dis, -500, 1000);
		
		controls = new THREE.OrbitControls(camera, renderer.domElement);
		projector = new THREE.Projector();
		
		//線の設定
		lineMaterial = new THREE.LineBasicMaterial( {color: 0x000000, linewidth:1} );
		
		//面の設定
		planeMaterialA = new THREE.MeshBasicMaterial({ color: 0x009FE8, opacity:0.1, side:THREE.DoubleSide, transparent:true});
		planeMaterialB = new THREE.MeshBasicMaterial({ color: 0x009FE8, opacity:0.35, side:THREE.DoubleSide, transparent:true});
		arcMaterial = new THREE.MeshBasicMaterial({color:0xE8259E, opacity:0.4, transparent:true});
		
		obj = new THREE.Object3D();
		
		pA = new THREE.Object3D();
		pB = new THREE.Object3D();
		
		obj.add(pA);
		obj.add(pB);
		
		//各面の設定
		var gA = new THREE.PlaneGeometry(pW, pD, 1, 1);
		var gB = new THREE.PlaneGeometry(pW, pD, 1, 1);
		
		var planeA = new THREE.Mesh(gA, planeMaterialA);
		var planeB = new THREE.Mesh(gB, planeMaterialB);
		
		pA.add(planeA);
		planeA.position.x = pW/2;
		planeA.rotation.x = Math.PI/2;
		
		pB.add(planeB);
		planeB.position.x = pW/2;
		planeB.rotation.x = Math.PI/2;
		
		//面の枠
		var gf = new THREE.Geometry();
		gf.vertices.push(
				new THREE.Vector3(0, 0, pD/2),
				new THREE.Vector3(pW, 0, pD/2),
				new THREE.Vector3(pW, 0, -pD/2),
				new THREE.Vector3(0, 0, -pD/2),
				new THREE.Vector3(0, 0, pD/2)
				);
		var frameA = new THREE.Line(gf, lineMaterial);
		var frameB = new THREE.Line(gf, lineMaterial);
		
		pA.add(frameA);
		pB.add(frameB);
		
		pB.rotation.z = Math.PI * 80/180;
		
		//線
		var gl = new THREE.Geometry();
		gl.vertices.push(
			new THREE.Vector3(1, 0, 0),
			new THREE.Vector3(1, 0, 1),
			new THREE.Vector3(0, 0, 1),
			new THREE.Vector3(0, 0, 0),
			new THREE.Vector3(pW * 4/5, 0, 0)
			);
		lineA = new THREE.Line(gl, lineMaterial);
		lineB = new THREE.Line(gl, lineMaterial);
		
		pA.add(lineA);
		pB.add(lineB);
		
		
		//角度の設定
		arc0 = new THREE.Mesh();
		arc0.material = arcMaterial;
		obj.add(arc0);
		
		arc1 = new THREE.Mesh();
		arc1.material = arcMaterial;
		arc1.rotation.z = Math.PI;
		obj.add(arc1);
		
		changeArcHandler();
		
		//文字の設定
		var tm = new THREE.MeshBasicMaterial({color:0x000000, opacity:1, transparent:false});
		
		var tA = new THREE.Mesh(getTextGeometry("α"), tm);
		var objA = new THREE.Object3D();
		tA.rotation.x = -Math.PI/2;
		objA.add(tA);
		objA.rotation.y = Math.PI/2;
		pA.add(objA);
		
		objA.position.x = pW * 0.9;
		objA.position.z = pD/2 * 0.9;
		
		var tB = new THREE.Mesh(getTextGeometry("β"), tm);
		var objB = new THREE.Object3D();
		tB.rotation.y = Math.PI/2;
		objB.add(tB);
		objB.rotation.z = -Math.PI/2;
		pB.add(objB);
		
		objB.position.x = pW * 0.8;
		objB.position.z = pD/2 * 0.9;
		objB.position.y = 0.1;
		
		//外に出す文字
		textArray = [];
		var tO = new THREE.Mesh(getTextGeometry("O"), tm);
		scene.add(tO);
		tO.position.y = -2;
		textArray[0] = tO;
		
		var tM = new THREE.Mesh(getTextGeometry("m"), tm);
		scene.add(tM);
		tM.position.x = pW * 0.8;
		tM.position.y = 1;
		textArray[1] = tM;
		
		var tN = new THREE.Mesh(getTextGeometry("n"), tm);
		scene.add(tN);
		tN.position.x = pW * 0.85 * Math.cos(pB.rotation.z);
		tN.position.y = pW * 0.85 * Math.sin(pB.rotation.z);
		textArray[2] = tN;
		
		document.getElementById("modelBlock").appendChild(renderer.domElement);
		
		camera.position.x = 70;
		camera.position.y = 60;
		camera.position.z = 80;
		
		scene.add(obj);
		
		changeRotationNumber(80);
		
		render();
	}
	catch(e)
	{
		alert("init:" + e.toString());
	}
}

function changeRotationNumber(rot)
{
	document.getElementById("rotNum").innerHTML = rot + "°";
}

function getTextGeometry(str)
{
	var g = new THREE.TextGeometry(str,
			{
				size:1.5, 
				height:0.1,
				curveSegments:10,
				font: "helvetiker",
				weight: "normal",
				style: "normal",
				bevelThickness:1,
				bevelSize:0,
				bevelEnabled: false,
				material:0,
				extrudeMaterial:1
			});
	
	return g;
}

function changeArcHandler()
{
	try
	{
		var rot = pB.rotation.z%(Math.PI*2);
		var add = Math.PI*10/180;
		
		var pnt0;
		var pnt1;
		
		pnt0 = [new THREE.Vector3(0, 0, 0)];
		pnt0.push(new THREE.Vector3(leng, 0, 0));
		
		var i;
		
		pnt0.geometry = null;
		
		if(rot <= Math.PI)
		{
			arc1.visible = false;
			
			if(rot > add)
			{
				for(i=add; i<=rot; i+=add)
				{
					pnt0.push(new THREE.Vector3(leng * Math.cos(i), leng * Math.sin(i), 0));

					if(i+add > rot)
					{
						pnt0.push(new THREE.Vector3(leng * Math.cos(rot), leng * Math.sin(rot), 0));
						break;
					}
				}
			}
			else
			{
				pnt0.push(new THREE.Vector3(leng * Math.cos(rot), leng * Math.sin(rot), 0));
			}
			
			arc0.geometry = new THREE.ConvexGeometry(pnt0);
		}
		else
		{
			arc1.visible = true;
			
			arc1.geometry = null;
			
			for(i=add; i<=Math.PI; i+=add)
			{
				pnt0.push(new THREE.Vector3(leng * Math.cos(i), leng * Math.sin(i), 0));
			}
			
			arc0.geometry = new THREE.ConvexGeometry(pnt0);
			
			pnt1 = [new THREE.Vector3(0, 0, 0)];
			pnt1.push(new THREE.Vector3(leng, 0, 0));
			
			rot -= Math.PI;
			
			if(rot > add)
			{
				for(i=add; i<=rot; i+=add)
				{
					pnt1.push(new THREE.Vector3(leng * Math.cos(i), leng * Math.sin(i), 0));

					if(i+add > rot)
					{
						pnt1.push(new THREE.Vector3(leng * Math.cos(rot), leng * Math.sin(rot), 0));
						break;
					}
				}
			}
			else
			{
				pnt1.push(new THREE.Vector3(leng * Math.cos(rot), leng * Math.sin(rot), 0));
			}
			
			arc1.geometry = new THREE.ConvexGeometry(pnt1);
		}
	}
	catch(e)
	{
		alert("changeArcHandler:" + e.toString());
	}
}

function render()
{
	try
	{
		requestAnimationFrame(render);
		
		controls.update();
		
		for(var i=0; i<textArray.length; i++)
		{
			textArray[i].rotation.setFromRotationMatrix( camera.matrix );
		}
		
		renderer.render(scene, camera);
	}
	catch(e)
	{
		alert("render:" + e.toString());
	}
}

function rotatePlaneHandler(e)
{
	try
	{
		createjs.Ticker.reset();
		createjs.Ticker.setFPS(20);
		createjs.Ticker.addEventListener('tick', rotationHandler);
		
		if(e.currentTarget.id == "rotLeft")
		{
			rdFlag = false;
		}
		else
		{
			rdFlag = true;
		}
		
		if(e.type == "touchstart")
		{
			document.addEventListener("touchend", stopAnimeHandler);
		}
		else
		{
			document.addEventListener("mouseup", stopAnimeHandler);
		}
	}
	catch(e)
	{
		alert("rotatePlaneHandler:" + e.toString());
	}
}

function rotationHandler(e)
{
	var rot = pB.rotation.z * 180/Math.PI;
	
	if(rdFlag)
	{
		rot -= 2;
	}
	else
	{
		rot += 2;
	}
	
	if(rot > 360)
	{
		rot = rot - 360;
	}
	else if(rot < 0)
	{
		rot = 360+rot;
	}
	
	rot = Math.round(rot);
	
	pB.rotation.z = rot * Math.PI/180;
	
	textArray[2].position.x = pW * 0.85 * Math.cos(pB.rotation.z);
	textArray[2].position.y = pW * 0.85 * Math.sin(pB.rotation.z);
	
	changeArcHandler();
	
	changeRotationNumber(rot);
}

function movePointHandler(e)
{
	createjs.Ticker.reset();
	createjs.Ticker.setFPS(20);
	
	if(e.target.id == "moveDownBtn")
	{
		createjs.Ticker.addEventListener('tick', moveDownHandler);
	}
	else
	{
		createjs.Ticker.addEventListener('tick', moveUpHandler);
	}
	
	if(e.type == "touchstart")
	{
		document.addEventListener("touchend", stopAnimeHandler);
	}
	else
	{
		document.addEventListener("mouseup", stopAnimeHandler);
	}
}

function moveUpHandler(e)
{
	if(lineA.position.z - 0.2 > -pD/2)
	{
		lineA.position.z -= 0.2;
		lineB.position.z -= 0.2;
		arc0.position.z -= 0.2;
		arc1.position.z -= 0.2;
		textArray[0].position.z -= 0.2;
		textArray[1].position.z -= 0.2;
		textArray[2].position.z -= 0.2;
	}
	else
	{
		lineA.position.z = pD/2-1
		lineB.position.z = pD/2-1;
		arc0.position.z = pD/2-1
		arc1.position.z = pD/2-1
		textArray[0].position.z = pD/2-1
		textArray[1].position.z = pD/2-1
		textArray[2].position.z = pD/2-1
	}
}

function moveDownHandler(e)
{
	if(lineA.position.z + 0.2 < pD/2-1)
	{
		lineA.position.z += 0.2;
		lineB.position.z += 0.2;
		arc0.position.z += 0.2;
		arc1.position.z += 0.2;
		textArray[0].position.z += 0.2;
		textArray[1].position.z += 0.2;
		textArray[2].position.z += 0.2;
	}
	else
	{
		lineA.position.z = -pD/2;
		lineB.position.z = -pD/2;
		arc0.position.z = -pD/2;
		arc1.position.z = -pD/2;
		textArray[0].position.z = -pD/2;
		textArray[1].position.z = -pD/2;
		textArray[2].position.z = -pD/2;
	}
}

function stopAnimeHandler(e)
{
	createjs.Ticker.reset();
	
	if(e.type == "touchend")
	{
		document.removeEventListener("touchend", stopAnimeHandler);
	}
	else
	{
		document.removeEventListener("mouseup", stopAnimeHandler);
	}
}


function changeCameraPositionHandler(e)
{
	camera.position.x = 0;
	camera.position.y = 0;
	camera.position.z = 80;
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = camera.position.x;
		array[0][1] = camera.position.y;
		array[0][2] = camera.position.z;
		array[0][3] = controls.object.zoom;
		
		var rot = document.getElementById("rotNum").innerHTML;
		rot = parseInt(rot.substring(0, rot.length-1));
		
		array[1] = [];
		array[1][0] = rot;
		array[1][1] = lineA.position.z;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}


function loadContent(array)
{
	try
	{
		camera.position.x = array[0][0];
		camera.position.y = array[0][1];
		camera.position.z = array[0][2];
		
		controls.object.zoom = array[0][3];
		controls.object.updateProjectionMatrix();
		
		var rot = array[1][0];
		
		pB.rotation.z = Math.PI * rot/180;
		changeRotationNumber(rot);
		
		var d = array[1][1];
		
		lineA.position.z = d;
		lineB.position.z = d;
		arc0.position.z = d;
		arc1.position.z = d;
		textArray[0].position.z = d;
		textArray[1].position.z = d;
		textArray[2].position.z = d;
		
		textArray[2].position.x = pW * 0.85 * Math.cos(pB.rotation.z);
		textArray[2].position.y = pW * 0.85 * Math.sin(pB.rotation.z);
		
		changeArcHandler();
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		
		controls.reset();
		
		//カメラの位置
		camera.position.x = 70;
		camera.position.y = 60;
		camera.position.z = 80;
		
		//拡大の初期化
		controls.object.zoom = 1;
		controls.object.updateProjectionMatrix();
		
		pB.rotation.z = Math.PI * 80/180;
		changeRotationNumber(80);
		
		textArray[2].position.x = pW * 0.85 * Math.cos(pB.rotation.z);
		textArray[2].position.y = pW * 0.85 * Math.sin(pB.rotation.z);
		
		changeArcHandler();
		
		lineA.position.z = 0;
		lineB.position.z = 0;
		arc0.position.z = 0;
		arc1.position.z = 0;
		textArray[0].position.z = 0;
		textArray[1].position.z = 0;
		textArray[2].position.z = 0;
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}






