// JavaScript Document
//相関係数
function correlation_coefficient(ar0, ar1)
{
	try
	{
		if(ar0.length == ar1.length)
		{
			var cov = covariance(ar0, ar1);
			var st0 = standard_deviation(ar0);
			var st1 = standard_deviation(ar1);
			
			var r = cov/(st0 * st1);
			
			return r;
		}
		else
		{
			return false;
		}
	}
	catch(e)
	{
		alert("correlation_coefficient:" + e.toString());
	}
}

//共分散
function covariance(ar0, ar1)
{
	try
	{
		if(ar0.length == ar1.length)
		{
			var sum = 0;
			
			var av0 = average(ar0);
			var av1 = average(ar1);
			
			for(var i=0; i<ar0.length; i++)
			{
				sum += (ar0[i]-av0) * (ar1[i]-av1);
			}
			
			sum = sum/ar0.length;
			
			return sum;
		}
		else
		{
			return false;
		}
	}
	catch(e)
	{
		alert("covariance:" + e.toString());
	}
}


//標準偏差
function standard_deviation(ar)
{
	try
	{
		var av = average(ar);
		
		var sum = 0;
		
		for(var i=0; i<ar.length; i++)
		{
			sum += (ar[i]-av)*(ar[i]-av);
		}
		
		sum = Math.sqrt(sum/ar.length);
		
		return sum;
	}
	catch(e)
	{
		alert("standard_deviation:" + e.toString());
	}
}

//平均
function average(ar)
{
	try
	{
		var sum=0;
		
		//加算
		for(var i=0; i<ar.length; i++)
		{
			sum+=ar[i];
		}
		
		//平均
		sum = sum/ar.length;
		
		return sum;
	}
	catch(e)
	{
		alert("average:" + e.toString());
	}
}