// JavaScript Document           
var scene;
var camera;
var renderer;
var controls;

var projector;

var obj;

var plane;
var line;
var lineMaterial;
var conv;
var covMaterial;

var prevRadius;

var crossSection;

var textArray;

var cW;
var cH;
var cD;

//断面の変化する値
var pNum;
var qNum;
var rNum;

var mesh;

var mouse;

var selectArray;

function initModel(w, h, d, p, q, r, t)
{
	try
	{
		scene = new THREE.Scene();
		
		//camera = new THREE.PerspectiveCamera(60, 800 / 450, 0.1, 1000);
		camera = new THREE.OrthographicCamera (-16, 16, 9, -9, 0.1, 1000);
		
		renderer = new THREE.WebGLRenderer({antialias: true});
		
		controls = new THREE.OrbitControls(camera, renderer.domElement);
		
		projector = new THREE.Projector();
		
		renderer.setSize(800, 450);
		renderer.setClearColor( new THREE.Color(0xFFFFFF) );
		
		document.getElementById("modelBlock").appendChild(renderer.domElement);
		renderer.domElement.style.position = "relative";
		
		//それぞれのマテリアルをまとめる
		obj = new THREE.Object3D();
		obj.name = "obj";
		
		mouse = {x:0, y:0};
		
		cW = w;
		cH = h;
		cD = d;
		
		//直方体（もしくは立方体）の辺を作成
		lineMaterial = new THREE.LineBasicMaterial( {color: 0x000000, linewidth:2 } );
		
		var lgTop = new THREE.Geometry();
		lgTop.vertices.push(new THREE.Vector3(-w/2, h/2, -d/2));
		lgTop.vertices.push(new THREE.Vector3(-w/2, h/2, d/2));
		lgTop.vertices.push(new THREE.Vector3(w/2, h/2, d/2));
		lgTop.vertices.push(new THREE.Vector3(w/2, h/2, -d/2));
		lgTop.vertices.push(new THREE.Vector3(-w/2, h/2, -d/2));
		
		var lgBottom = new THREE.Geometry();
		lgBottom.vertices.push(new THREE.Vector3(-w/2, -h/2, -d/2));
		lgBottom.vertices.push(new THREE.Vector3(-w/2, -h/2, d/2));
		lgBottom.vertices.push(new THREE.Vector3(w/2, -h/2, d/2));
		lgBottom.vertices.push(new THREE.Vector3(w/2, -h/2, -d/2));
		lgBottom.vertices.push(new THREE.Vector3(-w/2, -h/2, -d/2));
		
		var lgSide0 = new THREE.Geometry();
		lgSide0.vertices.push(new THREE.Vector3(-w/2, -h/2, -d/2));
		lgSide0.vertices.push(new THREE.Vector3(-w/2, h/2, -d/2));
		
		var lgSide1 = new THREE.Geometry();
		lgSide1.vertices.push(new THREE.Vector3(-w/2, -h/2, d/2));
		lgSide1.vertices.push(new THREE.Vector3(-w/2, h/2, d/2));
		
		var lgSide2 = new THREE.Geometry();
		lgSide2.vertices.push(new THREE.Vector3(w/2, -h/2, d/2));
		lgSide2.vertices.push(new THREE.Vector3(w/2, h/2, d/2));
		
		var lgSide3 = new THREE.Geometry();
		lgSide3.vertices.push(new THREE.Vector3(w/2, -h/2, -d/2));
		lgSide3.vertices.push(new THREE.Vector3(w/2, h/2, -d/2));
		
		
		var lineTop = new THREE.Line(lgTop, lineMaterial);
		var lineBottom = new THREE.Line(lgBottom, lineMaterial);
		var lineSide0 = new THREE.Line(lgSide0, lineMaterial);
		var lineSide1 = new THREE.Line(lgSide1, lineMaterial);
		var lineSide2 = new THREE.Line(lgSide2, lineMaterial);
		var lineSide3 = new THREE.Line(lgSide3, lineMaterial);
		
		
		//点の選択用オブジェクトを設定
		/*
		selectArray = [];
		var sphereMaterial = new THREE.MeshBasicMaterial({color:0xFF0000, opacity:0.5});
		var sphereGeometry = new THREE.SphereGeometry(1.5);
		
		sphereMaterial.transparent = true;
		sphereMaterial.opacity = 0.1;
		
		for(var i=0; i<6; i++)
		{
			var pnt = new THREE.Mesh(sphereGeometry, sphereMaterial);
			
			var pObj = new THREE.Object3D();
			pObj.name = "p" + i;
			pObj.add(pnt);
			
			selectArray[i] = pObj;
			obj.add(pObj);
		}
		
		//座標の設定
		selectArray[0].position.set(-w/2, h/2, d/6);
		selectArray[1].position.set(-w/2, h/2, -d/6);
		selectArray[2].position.set(-w/2, h/2, -d/2);
		selectArray[3].position.set(-w/2, h/6, d/2);
		selectArray[4].position.set(-w/2, -h/6, d/2);
		selectArray[5].position.set(-w/2, -h/2, d/2);
		*/
		
		obj.add(lineTop);
		obj.add(lineBottom);
		obj.add(lineSide0);
		obj.add(lineSide1);
		obj.add(lineSide2);
		obj.add(lineSide3);
		
		scene.add(obj);
		
		if(t == 0)
		{
			convMaterial = new THREE.MeshBasicMaterial( { color: 0x009FE8, opacity:0.2, transparent:true } );
		}
		else if(t == 1)
		{
			convMaterial = new THREE.MeshBasicMaterial( { color: 0xF9BF58, opacity:0.5, transparent:true } );
		}
		else
		{
			
		}
		
		pNum = p;
		qNum = q;
		rNum = r;
		
		var pArray = getSurfaceArray();
		
		plane = new THREE.Object3D();
		changeConvex(pArray);
		
		obj.add(plane);
		
		prevRadius = [obj.rotation.x, obj.rotation.y, obj.rotation.z];
		
		camera.position.x = -12.47898;
		camera.position.y = 2.62306;
		camera.position.z = 15.40760;
		
		textArray = new Array();
		var tm = new THREE.MeshLambertMaterial({color:0x000000, opacity:1, transparent:true});
		
		//頂点の記号
		for(var a=0; a < 11; a++)
		{
			var str = "A";
			if(a>0 && a <= 7)
			{
				str = String.fromCharCode(str.charCodeAt()+a);
			}
			else if(a == 8)
			{
				str = "P";
			}
			else if(a == 9)
			{
				str = "Q";
			}
			else if(a == 10)
			{
				str = "R";
			}
			
			var tg = new THREE.TextGeometry(str,
				{
					size:0.75, 
					height:0.01,
					curveSegments:10,
					font: "helvetiker",
					weight: "normal",
					style: "normal",
					bevelThickness:1,
					bevelSize:0,
					bevelEnabled: false,
					material:0,
					extrudeMaterial:1
				});
			
			var array = [new THREE.Mesh(tg, tm), tg, tm];
			textArray[a] = array;
			scene.add(textArray[a][0]);
		}
		
		//window.addEventListener("touchstart", selectPointHandler);
		//window.addEventListener("mousedown", selectPointHandler);
		
		
		changeTextPosition();
		
		render();
	}
	catch(e)
	{
		alert("init:" +e.toString());
	}
}


function selectPointHandler(e)
{
	try
	{
		if(e.target == renderer.domElement && rotFlag == false)
		{
			//マウス座標2D変換
       		var rect = e.target.getBoundingClientRect();    
			mouse.x =  e.clientX - rect.left;
			mouse.y =  e.clientY - rect.top;
			
			//マウス座標3D変換 width（横）やheight（縦）は画面サイズ
			mouse.x =  (mouse.x / 800) * 2 - 1;           
			mouse.y = -(mouse.y / 450) * 2 + 1;
			
			// マウスベクトル
			var vector = new THREE.Vector3( mouse.x, mouse.y ,1);
			
			// vector はスクリーン座標系なので, オブジェクトの座標系に変換
			//projector.unprojectVector( vector, camera );
			
			// 始点, 向きベクトルを渡してレイを作成
			var ray = new THREE.Raycaster( camera.position, vector.sub( camera.position ).normalize());
			
			//それぞれのあたり判定の必要なオブジェクトをチェック
        	var intersects;
			
			for(var i=0; i<selectArray.length; i++)
			{
				intersects = ray.intersectObjects(selectArray[i].children);
				
				if(intersects.length > 0)
				{
					break;
				}
			}
		}
	}
	catch(e)
	{
		alert("selectPointHandler:" + e.toString());
	}
}
		
function changeConvex(p)
{
	try
	{
		crossSection = p;
		
		while(plane.children != "")
		{
			plane.remove(line);
			plane.remove(conv);	
		}
		
		var pv = [];
		var i;
		for(i=0; i<p.length; i++)
		{
			pv.push(new THREE.Vector3(p[i][0], p[i][1], p[i][2]));	
		}
		
		if(pNum != 0 && qNum != 0)
		{
			conv = new THREE.Mesh(new THREE.ConvexGeometry(pv), convMaterial);
		}
		
		var geometry = new THREE.Geometry();
		
		for(i=0; i<pv.length; i++)
		{
			geometry.vertices.push(pv[i]);
		}
		
		geometry.vertices.push(pv[0]);
		
		line = new THREE.Line(geometry, lineMaterial);
		
		plane.add(conv);
		plane.add(line);
	}
	catch(e)
	{
		alert("changeConvex:" + e.toString());
	}
}

function getSurfaceArray()
{
	var array = [
			[-cW/2, cH/2, cD/2 - cD * pNum/3],
			[-cW/2, cH/2 - cH * qNum/3, cD/2],
			[-cW/2 + cW * rNum/3, cH/2, cD/2]
		];
	
	return array;	
}

function changeTextPosition()
{
	var subNum = 0.25;
	
	for(var a=0; a < textArray.length; a++)
	{
		var px;
		var py;
		var pz;
		
		var pArray = getSurfaceArray();
		
		//立方体の頂点
		if(a < textArray.length-3)
		{
			//x座標
			if(a%4 < 2)
			{
				px = -cW/2;
			}
			else
			{
				px = cW/2;
			}
			
			//y座標
			if(a/4 < 1)
			{
				py = cH/2;
			}
			else
			{
				py = -cH/2;
			}
			
			//z座標
			if(a%4==0 || a%4 == 3)
			{
				pz = -cD/2;
			}
			else
			{
				pz = cD/2;
			}
		}
		//Pの座標
		else if(a == 8)
		{
			px = pArray[0][0];
			py = pArray[0][1];
			pz = pArray[0][2];
		}
		//Qの座標
		else if(a == 9)
		{
			px = pArray[1][0];
			py = pArray[1][1];
			pz = pArray[1][2];
		}
		//Rの座標
		else if(a == 10)
		{
			px = pArray[2][0];
			py = pArray[2][1];
			px = pArray[2][2];
		}
		
		if(px >= 0)
		{
			px += subNum;	
		}
		else
		{
			px -= subNum;
		}
		
		if(py >= 0)
		{
			py += subNum;	
		}
		else
		{
			py -= subNum;
		}
		
		if(pz >= 0)
		{
			pz += subNum;	
		}
		else
		{
			pz -= subNum;
		}
		
		var v = obj.localToWorld(new THREE.Vector3(px, py, pz));
		
		textArray[a][0].position.x = v.x;
		textArray[a][0].position.y = v.y;
		textArray[a][0].position.z = v.z;
		
		//Pのテキスト設定
		if(a == 8)
		{
			if(pNum == 3)
			{
				textArray[0][0].visible = false;
				
				if(textArray[8][0].visible == false)
				{
					textArray[8][0].visible = true;
				}
			}
			else
			{
				textArray[0][0].visible = true;
				
				if(pNum == 0)
				{
					textArray[8][0].visible = false;
				}
				else if(textArray[8][0].visible == false)
				{
					textArray[8][0].visible = true;
				}
			}
		}
		else if(a == 9)
		{
			if(qNum == 3)
			{
				textArray[5][0].visible = false;
				
				if(textArray[9][0].visible == false)
				{
					textArray[9][0].visible = true;
				}
			}
			else
			{
				textArray[5][0].visible = true;
				
				if(qNum == 0)
				{
					textArray[9][0].visible = false;
				}
				else if(textArray[9][0].visible == false)
				{
					textArray[9][0].visible = true;
				}
			}
		}
		else if(a == 10)
		{
			textArray[10][0].visible = false;
		}
	}
}

var lastTime = 0;
var vendors = [ 'ms', 'moz', 'webkit', 'o' ];
for( var x = 0, limit = vendors.length; x < limit && !window.requestAnimationFrame; ++x ) {
    window.requestAnimationFrame = window[ vendors[ x ]+'RequestAnimationFrame' ];
    window.cancelAnimationFrame = window[ vendors[ x ]+'CancelAnimationFrame' ] || window[ vendors[ x ]+'CancelRequestAnimationFrame' ];
}

if(!window.requestAnimationFrame)
{
	window.requestAnimationFrame = function( callback )
	{
        var currTime = new Date().getTime();
        var timeToCall = Math.max( 0, 16 - ( currTime - lastTime ) );
        var id = window.setTimeout( function() { callback( currTime + timeToCall ); }, timeToCall );
        lastTime = currTime + timeToCall;
        return id;
	}
}

function render()
{
	try
	{
		requestAnimationFrame(render);
		
		controls.update();
		
		for(var i=0; i<textArray.length; i++)
		{
			textArray[i][0].rotation.setFromRotationMatrix( camera.matrix );
		}
		
		renderer.render(scene, camera);
	}
	catch(e)
	{
		alert("render:" + e.toString());
	}
}

function changeSurfacePosition(p, q, r)
{
	try
	{
		pNum = p;
		qNum = q;
		rNum = r;
		
		var pArray = getSurfaceArray();
		
		changeConvex(pArray);
		
		changeTextPosition();
		
	}
	catch(e)
	{
		alert("changeSurfacePosition:" + e.toString());	
	}
}

	
//3点を通る円の中心座標
function getCircleCenter(v0, v1, v2)
{
	var c = new Array();
	
	try
	{
		//各2点のベクトル
		//AB
		var c = Math.sqrt((v0[0]-v1[0])*(v0[0]-v1[0]) + (v0[1]-v1[1])*(v0[1]-v1[1]) + (v0[2]-v1[2])*(v0[2]-v1[2]));
		//BC
		var a = Math.sqrt((v1[0]-v2[0])*(v1[0]-v2[0]) + (v1[1]-v2[1])*(v1[1]-v2[1]) + (v1[2]-v2[2])*(v1[2]-v2[2]));
		//CA
		var b = Math.sqrt((v2[0]-v0[0])*(v2[0]-v0[0]) + (v2[1]-v0[1])*(v2[1]-v0[1]) + (v2[2]-v0[2])*(v2[2]-v0[2]));
		
		//ヘロンの公式を用いた3角形の面積は√s(s-a)(s-b)(s-c) で　s=(a+b+c)/2
		var s = (a+b+c)/2;
		//面積
		var area = s * (s-a)*(s-b)*(s-c);
		
		var p = a * a * (b*b+c*c-a*a) / (16 * area);
		var q = b * b * (c*c+a*a-b*b) / (16 * area);
		var r = c * c * (a*a+b*b-c*c) / (16 * area);
		
		c[0] = p * v0[0] + q * v1[0] + r * v2[0];
		c[1] = p * v0[1] + q * v1[1] + r * v2[1];
		c[2] = p * v0[2] + q * v1[2] + r * v2[2];
	}
	catch(e)
	{
		alert("getCircleCenter:" + e.toString());
	}
	
	return c;
}

//3点から法線ベクトルを算出
function getNormalVector(v0, v1, v2)
{
	var n = new Array();
	
	try
	{
		// 頂点を結ぶベクトルを算出
		var vec1 = [v1[0] - v0[0], v1[1] - v0[1], v1[2] - v0[2]];
		var vec2 = [v2[0] - v0[0], v2[1] - v0[1], v2[2] - v0[2]];
		
		// ベクトル同士の外積
		n[0] = vec1[1] * vec2[2] - vec1[2] * vec2[1];
		n[1] = vec1[2] * vec2[0] - vec1[0] * vec2[2];
		n[2] = vec1[0] * vec2[1] - vec1[1] * vec2[0];
	}
	catch(e)
	{
		alert("getNormalVector:" + e.toString());
	}
	
	return n;
}

//点p0から見た点p1の回転角
function getPointRotation(p0, p1)
{
	var r = new Array();
	//ｘ軸
	r[0] = Math.atan2(p1[1]-p0[1], p1[0]-p0[0]);
	//y軸
	r[1] = Math.atan2(p1[2]-p0[2], p1[1]-p0[1]);
	//z軸
	r[2] = Math.atan2(p1[0]-p0[0], p1[2]-p0[2]);
	
	return r;
}

//法線ベクトルからの角度を算出
function getRadiusFromNormalVector(x0, y0, z0)
{
	var r = new Array();
	
	try
	{
		var absVec = Math.sqrt(x0 * x0 + y0 * y0 + z0 * z0);
		
		r[0] = x0/absVec;
		r[1] = y0/absVec;
		r[2] = z0/absVec;
		
	}
	catch(e)
	{
		alert("getRadiusFromNormalVector:" + e.toString());
	}
	
	return r;
}

function showCrossSection()
{
	try
	{
		//現在の回転角を保存
		prevRadius[0] = obj.rotation.x;
		prevRadius[1] = obj.rotation.y;
		prevRadius[2] = obj.rotation.z;
		
		//平面の法線ベクトル
		var v = getNormalVector(crossSection[0], crossSection[1], crossSection[2]);
		
		//平面の回転角
		var r = getRadiusFromNormalVector(v[0], v[1], v[2]);
		
		alert(r[0] * 180/Math.PI +", "+ r[1] * 180/Math.PI +", "+ r[2] * 180/Math.PI);
		
		obj.rotation.x = -r[0];
		obj.rotation.y = -r[1];
		obj.rotation.z = -r[2];
	}
	catch(e)
	{
		alert("showCrossSection:" + e.toString());
	}
}


function getPointLength(x0, y0, z0, x1, y1, z1)
{
	var length = Math.sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0)+(z1-z0)*(z1-z0));
	
	return length;	
}